# -*- coding: utf-8 -*-
"""
Created on Sun Jan 23 10:35:18 2022

@author: CUI Atd
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns

sns.set_style("white")

# Creating the data frame
df = pd.read_csv('F:\\UET TEACHING\\Students\\MS Students\\COMSATS\\Sara Sheikh\\Paper\\Updated paper\\6-12-2021\\Dataset\\DatasetCNN.csv')


# Labels are the values we want to predict
target = np.array(df['CodedSADClass'])
# Saving feature names for later use
features = df[df.columns[0:5]]



#feature_list = list(features.columns)
# Convert to numpy array
features = np.array(features)

"""
As there are no missing values, therefore dont need 
the following missing values analysis code

from numpy import isnan
from sklearn.impute import KNNImputer
# print total missing
print('Missing: %d' % sum(isnan(features).flatten()))
# define imputer
imputer = KNNImputer(missing_values=np.nan)
# fit on the dataset
imputer.fit(features)
# transform the dataset
features_trans = imputer.transform(features)
# print total missing
print('Missing: %d' % sum(isnan(features_trans).flatten()))
"""

from sklearn.model_selection import train_test_split
x_train, x_val, y_train, y_val = train_test_split(features, target, test_size=0.30, random_state=8)

x_val, x_test, y_val, y_test = train_test_split(x_val, y_val, test_size=0.50, random_state=8)


#import pytorch_tabnet
from pytorch_tabnet.tab_model import TabNetClassifier
#from pytorch_tabnet.multitask import TabNetMultiTaskClassifier
import torch

#from sklearn.preprocessing import LabelEncoder
#from sklearn.metrics import roc_auc_score, accuracy_score
#from sklearn.model_selection import KFold

np.random.seed(8)


# define the model
clf1_nopreproc = TabNetClassifier(optimizer_fn=torch.optim.Adam,
                       optimizer_params=dict(lr=2e-2),
                       scheduler_params={"step_size":10, # how to use learning rate scheduler
                                         "gamma":0.9},
                       scheduler_fn=torch.optim.lr_scheduler.StepLR,
                       mask_type='entmax' # "sparsemax"
                      )

#print(len(y_train))

# fit the model 
clf1_nopreproc.fit(
    x_train,y_train,
    eval_set=[(x_train, y_train), (x_val, y_val)],
    eval_name=['train', 'valid'],
    eval_metric=['accuracy', 'logloss'],
    max_epochs=500 , patience=50,
    batch_size=9000, virtual_batch_size=4500,
    num_workers=0,
    weights=1,
    drop_last=False
)            


# plot losses
plt.plot(clf1_nopreproc.history['loss'])

# plot accuracy
plt.plot(clf1_nopreproc.history['train_accuracy'])
plt.plot(clf1_nopreproc.history['valid_accuracy'])

# find and plot feature importance
y_pred = clf1_nopreproc.predict(x_test)
clf1_nopreproc.feature_importances_
feat_importances = pd.Series(clf1_nopreproc.feature_importances_, index=features.columns)
feat_importances.nlargest(20).plot(kind='barh')


# determine best accuracy for test set
preds = clf1_nopreproc.predict(x_test)
test_acc = accuracy_score(preds, y_test)

# determine best accuracy for validation set
preds_valid = clf1_nopreproc.predict(x_val)
valid_acc = accuracy_score(preds_valid, y_val)

print(f"BEST ACCURACY SCORE ON VALIDATION SET : {valid_acc}")
print(f"BEST ACCURACY SCORE ON TEST SET : {test_acc}")